#
# Sample device based on the emulator for testing SE4Android CIL policy
#

# NOTE: Some of the entries have been taken from:
#                       build/target/board/generic/device.mk

# Make complete build the same as "aosp_arm".
$(call inherit-product, $(SRC_TARGET_DIR)/product/full.mk)

# Becomes the TARGET_DEVICE
PRODUCT_NAME := cil_device

# Must be the directory name where the BoardConfig.mk resides
PRODUCT_DEVICE := cil_device

# This is displayed in "About Phone" of the settings app.
# Also ro.product.model property
PRODUCT_MODEL := CIL Device

PRODUCT_MANUFACTURER := Acme Ltd.

# Set locale to en_GB, this will set:
# ro.product.locale.language=en
# ro.product.locale.region=GB
PRODUCT_LOCALES := en_GB

# Reset the date format to a readable format.
PRODUCT_PROPERTY_OVERRIDES := \
    ro.com.android.dateformat=dd-MM-yyyy

# Build CIL compiler:
PRODUCT_PACKAGES += \
    secilc

# Build CIL policy for basic emulator services:
PRODUCT_PACKAGES += \
    cil_sepolicy \
    cil_seapp_contexts \
    cil_property_contexts \
    cil_service_contexts \
    cil_selinux_version

# Copy over the init.rc config file modified to support namespaces
PRODUCT_COPY_FILES += \
    device/demo_vendor/cil_device/cil_init.rc:root/init.rc

# bootanimation.zip - Rotating safe-penguin on startup screen.
PRODUCT_COPY_FILES += \
    device/demo_vendor/cil_device/animation/bootanimation.zip:system/media/bootanimation.zip

# This will set the config_multiuserMaximumUsers config.xml entry to 6 users.
# To check entry: adb shell su 0 pm get-max-users
DEVICE_PACKAGE_OVERLAYS := \
    device/demo_vendor/cil_device/overlay

# This is a test isolated service privileged app.
# The third_party_apps/RunIsolatedService/bin/RunIsolatedService.apk
# can be used to test as well.
PRODUCT_PACKAGES += \
    SE4A-IsolatedService

