#
# Build the CIL compiler for Android
#
LOCAL_PATH := $(call my-dir)
include $(CLEAR_VARS)

LOCAL_SRC_FILES := \
	src/cil_binary.c \
	src/cil_build_ast.c \
	src/cil.c \
	src/cil_copy_ast.c \
	src/cil_fqn.c \
	src/cil_list.c \
	src/cil_log.c \
	src/cil_mem.c \
	src/cil_parser.c \
	src/cil_policy.c \
	src/cil_post.c \
	src/cil_reset_ast.c \
	src/cil_resolve_ast.c \
	src/cil_stack.c \
	src/cil_strpool.c \
	src/cil_symtab.c \
	src/cil_tree.c \
	src/cil_verify.c \
    src/cil_lexer.l

LOCAL_C_INCLUDES += \
	$(LOCAL_PATH)/src \
	$(LOCAL_PATH)/include \
    external/libsepol/include

common_cflags := \
	-Wall -Wshadow -Wextra -Wmissing-format-attribute \
	-Wcast-align -Wstrict-prototypes -Wpointer-arith \
	-Wunused -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64

yacc_flags := -x c

#
# Build libcil.a
#
LOCAL_MODULE := libcil
LOCAL_MODULE_CLASS := STATIC_LIBRARIES
LOCAL_MODULE_TAGS := optional
LOCAL_YACCFLAGS := -v
LOCAL_CFLAGS := $(yacc_flags) $(common_cflags)

include $(BUILD_HOST_STATIC_LIBRARY)

##########################################
#
# Build secilc compiler
#
include $(CLEAR_VARS)
LOCAL_MODULE := secilc
LOCAL_MODULE_CLASS := EXECUTABLES
LOCAL_MODULE_TAGS := optional
LOCAL_SRC_FILES := secilc.c
LOCAL_C_INCLUDES += \
    $(LOCAL_PATH)/include \
    external/libsepol/include

LOCAL_CFLAGS := $(common_cflags)
LOCAL_STATIC_LIBRARIES := \
	libcil \
	libsepol

include $(BUILD_HOST_EXECUTABLE)

