#include <stdio.h>
#include <stdlib.h>
#include <selinux/selinux.h>

/* Get entries from $HOME/notebook.conf file */
extern void get_config_entry(char *entry, char **content);

int main(int argc, char **argv)
{
    int rc;
    security_context_t context;
    char *path;

#ifdef INFO
    printf("\nThe lgetfilecon example requires a file or directory name to be "
                "selected.\nIf the file is a symbolic link it will "
                "retrieve the context from the symbolic\nlink entries "
                "\"security.selinux\" attribute using the lgetxattr(2) "
				"system call.\nIf the file is not a symbolic link "
                "it acts as getfilecon.\n\nIf extended attributes are not "
                "supported, then errno = ENOTSUP (Operation not\nsupported) "
                "is returned.\nPress return to continue\n");
    getchar();
#endif

    get_config_entry("[path]", &path);

    printf("\nNow obtaining the file context via lgetfilecon_raw:\n");
    if ((rc = lgetfilecon_raw(path, &context)) == -1) {
        perror("lgetfilecon_raw - ERROR");
        exit(1);
    }
    printf("The \"security.selinux\" xattr context assigned to the file "
                            "is:\n\t%s length: %d\n", context, rc);
    freecon(context);
    free(path);
    exit(0);
}
