#include <stdio.h>
#include <stdlib.h>
#include <selinux/selinux.h>

/* Get entries from $HOME/notebook.conf file */
extern void get_config_entry(char *entry, char **content);

int main(int argc, char **argv)
{
    int rc;
    char *name;

#ifdef INFO
    printf("\nThe security_get_boolean_pending example requires a boolean name "
				"to be\nselected. The pending value will then be displayed."
				"\nPress return to continue\n");
    getchar();
#endif

    get_config_entry("[boolean]", &name);

    printf("Executing: security_get_boolean_pending(%s);\n", name);

    if ((rc = security_get_boolean_pending(name)) == -1) {
        printf("FAILED to get boolean pending for %s\n", name);
        perror("security_get_boolean_pending - ERROR");
    }
    else
        printf("\nThe %s boolean pending status is %s\n\n",
										name, rc ? "true (1)" : "false (0)");

    exit(0);
}
